ServerComponent


import com.sas.metadata.remote.*
import org.apache.tools.ant.Project

def MetadataUtilityClass metadataConnection
def MdOMRConnection omrConnection
def MdFactoryImpl factory
def fqId
def reposId
def ReturnProperty log
def debug = false

// Metadata Server specific
def _metaDataHost       = attributes["metadatahost"]
def _metaDataPort       = attributes["metadataport"]
def _metaDataUser       = attributes["metadatauser"]
def _metaDataPassword   = attributes["metadatapassword"]
def _metaDataRepository = attributes["metadatarepository"]

// Server Component specific
def _serverType              = attributes["servertype"]
def _serverClassIdentifier   = attributes["serverclassidentifier"]
def _serverName              = attributes["servername"]
def _serverDesc              = attributes["serverdesc"]
def _majorVersion            = attributes["majorversion"]
def _minorVersion            = attributes["minorversion"]
def _swVendor                = attributes["swvendor"]
def _serverProductIdentifier = attributes["serverproductidentifier"]
def _serverProductName       = attributes["serverproductname"]

// Connection specific
def _connectionType           = attributes["connectiontype"]
def _connectionName           = attributes["connectionname"]
def _serverHost               = attributes["serverhost"]
def _serverPort               = attributes["serverport"]
def _appProtocol              = attributes["appprotocol"]
def _authenticationDomain     = attributes["authenticationdomain"]
def _authenticationType       = attributes["authenticationtype"]
def _connectionDesc           = attributes["connectiondesc"]
def _associateMachine         = attributes["associatemachine"]
def _connectionOverwriteArray = attributes["connectionoverwritearray"]

// Oozie Server specific
def _oozieConfigDirForHadoop = attributes["oozieconfigdirforhadoop"]
def _oozieWorkflowDir        = attributes["oozieworkflowdir"]
def _oozieCoordinatorDir     = attributes["ooziecoordinatordir"]

// Extensions
def _extensionDelim                    = attributes["extensiondelim"]
def _extensionNameArray                = attributes["extensionnamearray"]
def _extensionPropertyNameArray        = attributes["extensionpropertynamearray"]
def _extensionValueArray               = attributes["extensionvaluearray"]
def _extensionOverwriteValueArray      = attributes["extensionoverwritevaluearray"]
def _extensionPropertyTypeNameArray    = attributes["extensionpropertytypenamearray"]
def _extensionPropertyTypeSQLTypeArray = attributes["extensionpropertytypesqltypearray"]

// Misc
def _osLocalHostType   = attributes["oslocalhosttype"]

// Returned properties
def _outputproperty = attributes["outputproperty"]
def _resultproperty = attributes["resultproperty"]

Utility.antEcho(project, "_metaDataHost:       \"${_metaDataHost}\"", debug)
Utility.antEcho(project, "_metaDataPort:       \"${_metaDataPort}\"", debug)
Utility.antEcho(project, "_metaDataUser:       \"${_metaDataUser}\"", debug)
Utility.antEcho(project, "_metaDataPassword:   \"${_metaDataPassword}\"", debug)
Utility.antEcho(project, "_metaDataRepository: \"${_metaDataRepository}\"", debug)

Utility.antEcho(project, "_serverType:              \"${_serverType}\"", debug)
Utility.antEcho(project, "_serverClassIdentifier:   \"${_serverClassIdentifier}\"", debug)
Utility.antEcho(project, "_serverName:              \"${_serverName}\"", debug)
Utility.antEcho(project, "_serverDesc:              \"${_serverDesc}\"", debug)
Utility.antEcho(project, "_majorVersion:            \"${_majorVersion}\"", debug)
Utility.antEcho(project, "_minorVersion:            \"${_minorVersion}\"", debug)
Utility.antEcho(project, "_swVendor:                \"${_swVendor}\"", debug)
Utility.antEcho(project, "_serverProductIdentifier: \"${_serverProductIdentifier}\"", debug)
Utility.antEcho(project, "_serverProductName:       \"${_serverProductName}\"", debug)

Utility.antEcho(project, "_connectionType:           \"${_connectionType}\"", debug)
Utility.antEcho(project, "_connectionName:           \"${_connectionName}\"", debug)
Utility.antEcho(project, "_serverHost:               \"${_serverHost}\"", debug)
Utility.antEcho(project, "_serverPort:               \"${_serverPort}\"", debug)
Utility.antEcho(project, "_appProtocol:              \"${_appProtocol}\"", debug)
Utility.antEcho(project, "_authenticationDomain:     \"${_authenticationDomain}\"", debug)
Utility.antEcho(project, "_authenticationType:       \"${_authenticationType}\"", debug)
Utility.antEcho(project, "_connectionDesc:           \"${_connectionDesc}\"", debug)
Utility.antEcho(project, "_associateMachine:         \"${_associateMachine}\"", debug)
Utility.antEcho(project, "_connectionOverwriteArray: \"${_connectionOverwriteArray}\"", debug)

Utility.antEcho(project, "_oozieConfigDirForHadoop: \"${_oozieConfigDirForHadoop}\"", debug)
Utility.antEcho(project, "_oozieWorkflowDir:        \"${_oozieWorkflowDir}\"", debug)
Utility.antEcho(project, "_oozieCoordinatorDir:     \"${_oozieCoordinatorDir}\"", debug)

Utility.antEcho(project, "_extensionDelim:                    \"${_extensionDelim}\"", debug)
Utility.antEcho(project, "_extensionNameArray:                \"${_extensionNameArray}\"", debug)
Utility.antEcho(project, "_extensionPropertyNameArray:        \"${_extensionPropertyNameArray}\"", debug)
Utility.antEcho(project, "_extensionValueArray:               \"${_extensionValueArray}\"", debug)
Utility.antEcho(project, "_extensionOverwriteValueArray:      \"${_extensionOverwriteValueArray}\"", debug)
Utility.antEcho(project, "_extensionPropertyTypeNameArray:    \"${_extensionPropertyTypeNameArray}\"", debug)
Utility.antEcho(project, "_extensionPropertyTypeSQLTypeArray: \"${_extensionPropertyTypeSQLTypeArray}\"", debug)

Utility.antEcho(project, "_osLocalHostType: \"${_osLocalHostType}\"", debug)
Utility.antEcho(project, "_outputproperty:  \"${_outputproperty}\"", debug)
Utility.antEcho(project, "_resultproperty:  \"${_resultproperty}\"", debug)


// Metadata usage version
def usageVersion = 1000000

// antEcho only works when running from Ant, so println instead.
// debug = true

log = new ReturnProperty(_outputproperty, _resultproperty, project)

// List of attributes of a connection object to overwrite, when an existing connection is found
connectionOverwriteList = _connectionOverwriteArray.tokenize(",")
Map connectionOverwriteMap = [:]
if ( connectionOverwriteList.size() == 0 )
{
    connectionOverwriteMap.put( "all".toLowerCase(), "" )
}
else
{
   for (ii = 0; ii < connectionOverwriteList.size(); ii++)
   {
      connectionOverwriteMap.put( connectionOverwriteList[ii].toLowerCase(), "" )
   }
}
Utility.antEcho(project, "connectionOverwriteMap: ${connectionOverwriteMap}", debug)

// Connect to the server
Utility.antEcho(project, "Connecting to the metadata server.", debug)
try
{
   metadataConnection = new MetadataUtilityClass(project)
   metadataConnection.makeConnection(_metaDataHost, _metaDataPort, _metaDataUser, _metaDataPassword, _metaDataRepository)
}
catch (Exception e)
{
   Utility.antEcho(project, "makeConnection: "  + e.getMessage(), debug)
   log.returnProperty("1", "Error connecting to the Metadata Server: " +
         "\n" + e.getMessage() +
         "\n  Host: ${_metaDataHost}" +
         "\n  Port: ${_metaDataPort}}" +
         "\n  User: ${_metaDataUser}}" +
         "\n  Repository: ${_metaDataRepository}."
         );
   return;
}

try
{
   // Get things we will need.

   // Associated machine.  Tolerate if a zero length string is passed in.
   Machine assocMachine = null

   if (_serverHost != "" && _associateMachine.equalsIgnoreCase("true"))
   {
      assocMachine = metadataConnection.getMachine(_serverHost)
      if (assocMachine == null)
      {
         e1 = new MdException("The Machine, ${_serverHost}, was not found.")
         throw e1
      }
      else
      {
         Utility.antEcho(project, "The Machine, ${_serverHost}, was found.", debug)
      }
   }
   else
   {
      Utility.antEcho(project, "Either the serverHost passed in is a zero length string or we told not to associate this Connection to a Machine; tolerate this situation where the Machine is null.", debug)
   }

   // Authentication domain
   AuthenticationDomain authDomain = metadataConnection.getAuthDomain(_authenticationDomain)
   if (authDomain == null)
   {
      e1 = new MdException("The Authentication Domain, ${_authenticationDomain}, was not found.")
      throw e1
   }
   else
   {
      Utility.antEcho(project, "The Authentication Domain, ${_authenticationDomain}, was found.", debug)
   }

   if (_authenticationType == "")
   {
      _authenticationType="user/password"
   }

   // Update server component if it exists, else create it.
   def srvComp = metadataConnection.getServerComponent(_serverName)

   // If Server Component already exists
   if (srvComp != null)
   {
      Utility.antEcho(project, "Updating Server Component, ${_serverName}.", debug)

      // Update Server Component basic properties
      srvComp.with
      {
         setMajor             _majorVersion
         setMinor             _minorVersion
         setVendor            _swVendor
         setUsageVersion      usageVersion
         setDesc              _serverDesc
      }

      if ( assocMachine != null )
      {
          srvComp.setAssociatedMachine( assocMachine )
      }

      def propertiesOnSrvComp = srvComp.getProperties()

      // Update Server Type specific properties
      switch( _serverType )
      {
         case "oozie":
            srvComp.setProductIdentifier("Scheduler")
            srvComp.setProductName("Oozie")
            srvComp.setPublicType("Server.Oozie")

            metadataConnection.setThisProperty("Server.Oozie.Property.ConfigDir.xmlKey.txt"  , "HadoopConfig", "${_oozieConfigDirForHadoop}", "=", propertiesOnSrvComp, true)
            metadataConnection.setThisProperty("Server.Oozie.Property.Workflow.xmlKey.txt"   , "Workflow"    , "${_oozieWorkflowDir}"       , "=", propertiesOnSrvComp, true)
            metadataConnection.setThisProperty("Server.Oozie.Property.Coordinator.xmlKey.txt", "Coordinator" , "${_oozieCoordinatorDir}"    , "=", propertiesOnSrvComp, true)

            break

         default:
            srvComp.setClassIdentifier(_serverClassIdentifier)
            srvComp.setProductIdentifier(_serverProductIdentifier)
            srvComp.setProductName(_serverProductName)
            srvComp.setPublicType(_serverType)

            setExtensions( metadataConnection,
                           _extensionDelim,
                           _extensionNameArray,
                           _extensionPropertyNameArray,
                           _extensionValueArray,
                           _extensionOverwriteValueArray,
                           _extensionPropertyTypeNameArray,
                           _extensionPropertyTypeSQLTypeArray,
                           propertiesOnSrvComp,
                           debug )

            break
      }

      // Update Connection
      Connection connection = null;

      switch( _connectionType )
      {
         case "TCPIPConnection":
            connection = (TCPIPConnection)getConnection(srvComp, _connectionName, debug)

            // If didn't find a connection, then create a new one
            if ( connection == null )
            {
               Utility.antEcho(project, "Creating a new TCPIPConnection '${_connectionName}' for an existing Server Component '${_serverName}'.", debug)

               connection = (TCPIPConnection)metadataConnection.makeTCPIPConnection(_connectionName)

               def propertiesOnConnection = connection.getProperties()

               connection.setApplicationProtocol(_appProtocol)
               connection.setAuthenticationType(_authenticationType)
               connection.setCommunicationProtocol("tcp")
               connection.setHostName(_serverHost)
               connection.setPort(_serverPort)
               connection.setDesc(_connectionDesc)

               def domains = connection.getDomains()
               domains.removeAllElements()
               connection.setDomain(authDomain)

               // Associate the Connection to the Server Component
               def sConns = srvComp.getSourceConnections()
               sConns.add(connection)
            }
            // Else found an existing connection
            else
            {
               def propertiesOnConnection = connection.getProperties()

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("protocol"))
               { connection.setApplicationProtocol(_appProtocol) }

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("authtype"))
               { connection.setAuthenticationType(_authenticationType) }

               connection.setCommunicationProtocol("tcp")

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("hostname"))
               { connection.setHostName(_serverHost) }

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("port"))
               { connection.setPort(_serverPort) }

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("desc"))
               { connection.setDesc(_connectionDesc) }

               if (connectionOverwriteMap.containsKey("all") || connectionOverwriteMap.containsKey("authdom"))
               {
                  def domains = connection.getDomains()
                  domains.removeAllElements()
                  connection.setDomain(authDomain)
               }
            }

            break

         default:
            def e2 = new MdException("Invalid Connection type, \"${_connectionType}\".")
            throw e2
            break
      }

      srvComp.updateMetadataAll()

   }
   // Else need to create a new Server Component
   else
   {
      // Create Server Component
      Utility.antEcho(project, "Creating Server Component, ${_serverName}.", debug)

      def newSrvComp = metadataConnection.makeServerComponent(_serverName)

      // Update Server Component basic Properties
      newSrvComp.with
      {
         setMajor             _majorVersion
         setMinor             _minorVersion
         setVendor            _swVendor
         setUsageVersion      usageVersion
         setDesc              _serverDesc
      }

      if ( assocMachine != null )
      {
          newSrvComp.setAssociatedMachine( assocMachine )
      }

      def propertiesOnSrvComp = newSrvComp.getProperties()

      // Set Server Type specific properties
      switch ( _serverType )
      {
         case "oozie":
            newSrvComp.setClassIdentifier("ff3aab60-8926-4e88-8af3-4287787d7d7")  // Must match ClassIdentifier of the corresponding Prototype object for SMC to display correctly
            newSrvComp.setProductIdentifier("Scheduler")
            newSrvComp.setProductName("Oozie")
            newSrvComp.setPublicType("Server.Oozie")

            metadataConnection.setThisProperty("Server.Oozie.Property.ConfigDir.xmlKey.txt"  , "HadoopConfig", "${_oozieConfigDirForHadoop}", "=", propertiesOnSrvComp, true)
            metadataConnection.setThisProperty("Server.Oozie.Property.Workflow.xmlKey.txt"   , "Workflow"    , "${_oozieWorkflowDir}"       , "=", propertiesOnSrvComp, true)
            metadataConnection.setThisProperty("Server.Oozie.Property.Coordinator.xmlKey.txt", "Coordinator" , "${_oozieCoordinatorDir}"    , "=", propertiesOnSrvComp, true)

            break

         default:
            newSrvComp.setClassIdentifier(_serverClassIdentifier)
            newSrvComp.setProductIdentifier(_serverProductIdentifier)
            newSrvComp.setProductName(_serverProductName)
            newSrvComp.setPublicType(_serverType)

            setExtensions( metadataConnection,
                           _extensionDelim,
                           _extensionNameArray,
                           _extensionPropertyNameArray,
                           _extensionValueArray,
                           _extensionOverwriteValueArray,
                           _extensionPropertyTypeNameArray,
                           _extensionPropertyTypeSQLTypeArray,
                           propertiesOnSrvComp,
                           debug )

            break
      }

      // Add Connection
      Connection newConnection = null;

      switch( _connectionType )
      {
         case "TCPIPConnection":
            newConnection = (TCPIPConnection)metadataConnection.makeTCPIPConnection(_connectionName)

            def propertiesOnConnection = newConnection.getProperties()

            newConnection.setApplicationProtocol(_appProtocol)
            newConnection.setAuthenticationType(_authenticationType)
            newConnection.setCommunicationProtocol("tcp")
            newConnection.setHostName(_serverHost)
            newConnection.setPort(_serverPort)
            newConnection.setDesc(_connectionDesc)

            def domains = newConnection.getDomains()
            domains.removeAllElements()
            newConnection.setDomain(authDomain)

            break

         default:
            def e2 = new MdException("Invalid Connection type, \"${_connectionType}\".")
            throw e2
            break
      }

      // Associate the Connection to the Server Component
      def sConns = newSrvComp.getSourceConnections()
      sConns.add(newConnection)

      newSrvComp.updateMetadataAll()
   }

}
catch (Exception e2)
{
   Utility.antEcho(project, e2.getMessage(), debug)
   log.returnProperty("1", "Unable to create/update the server component.")
   metadataConnection.closeConnection()
   return
}

metadataConnection.closeConnection()

Utility.antEcho(project, "Successful end of script ServerComponent.groovy ( _serverName '${_serverName}'  _serverType '${_serverType}').", debug)
log.returnProperty("0", "Successful end of script ServerComponent.groovy.")


// Methods

Connection getConnection(serverComp, name, debug)
{
   AssociationList sConns = serverComp.getSourceConnections()
   def sConn = sConns.find { it.getName() == name }
   if (sConn == null)
   {
      Utility.antEcho(project, "Connection with name '${name}' was not found.  Returning null value.", debug)
   }
   return sConn
}

void setExtensions(metadataConnection,
                   extensionDelim,
                   extensionNameArray,
                   extensionPropertyNameArray,
                   extensionValueArray,
                   extensionOverwriteValueArray,
                   extensionPropertyTypeNameArray,
                   extensionPropertyTypeSQLTypeArray,
                   propertiesOnSrvComp,
                   debug)
{
   def extensionNameList                = extensionNameArray.tokenize               (extensionDelim)
   def extensionPropertyNameList        = extensionPropertyNameArray.tokenize       (extensionDelim)
   def extensionValueList               = extensionValueArray.tokenize              (extensionDelim)
   def extensionOverwriteValueList      = extensionOverwriteValueArray.tokenize     (extensionDelim)
   def extensionPropertyTypeNameList    = extensionPropertyTypeNameArray.tokenize   (extensionDelim)
   def extensionPropertyTypeSQLTypeList = extensionPropertyTypeSQLTypeArray.tokenize(extensionDelim)

   def listSize = extensionNameList.size()

   // Provide default values for the PropertyType array's (String)
   if (extensionOverwriteValueList.size() == 0 )
   {
      for (ii = 0; ii < listSize; ii++)
      {
         extensionOverwriteValueList.add( "true" )
         Utility.antEcho(project, "Provide default value '${extensionOverwriteValueList[ii]}' for 'OverwriteValue' for extension name '${extensionNameList[ii]}'", debug)
      }
   }

   if (extensionPropertyTypeNameList.size() == 0 )
   {
      for (ii = 0; ii < listSize; ii++)
      {
         extensionPropertyTypeNameList.add( "String" )
         Utility.antEcho(project, "Provide default value '${extensionPropertyTypeNameList[ii]}' for 'PropertyTypeName' for extension name '${extensionNameList[ii]}'", debug)
      }
   }

   if (extensionPropertyTypeSQLTypeList.size() == 0 )
   {
      for (ii = 0; ii < listSize; ii++)
      {
         extensionPropertyTypeSQLTypeList.add( "12" )
         Utility.antEcho(project, "Provide default value '${extensionPropertyTypeSQLTypeList[ii]}' for 'PropertyTypeSQLType' for extension name '${extensionNameList[ii]}'", debug)
      }
   }

   if ( extensionNameList.size() == extensionPropertyNameList.size()
     && extensionPropertyNameList.size() == extensionValueList.size()
     && extensionValueList.size() == extensionOverwriteValueList.size()
     && extensionOverwriteValueList.size() == extensionPropertyTypeNameList.size()
     && extensionPropertyTypeNameList.size() == extensionPropertyTypeSQLTypeList.size() )
   {
      Utility.antEcho(project, "Number of extensions: \"" + listSize + "\"", debug)

      for (ii = 0; ii < listSize; ii++)
      {
         def extName                = extensionNameList[ii]
         def extPropertyName        = extensionPropertyNameList[ii]
         def extValue               = extensionValueList[ii]
         def extOverwriteValue      = extensionOverwriteValueList[ii]
         def extPropertyTypeName    = extensionPropertyTypeNameList[ii]
         def extPropertyTypeSQLType = extensionPropertyTypeSQLTypeList[ii]

         Utility.antEcho(project, "extName:                \"${extName}\"", debug)
         Utility.antEcho(project, "extPropertyName:        \"${extPropertyName}\"", debug)
         Utility.antEcho(project, "extValue:               \"${extValue}\"", debug)
         Utility.antEcho(project, "extOverwriteValue:      \"${extOverwriteValue}\"", debug)
         Utility.antEcho(project, "extPropertyTypeName:    \"${extPropertyTypeName}\"", debug)
         Utility.antEcho(project, "extPropertyTypeSQLType: \"${extPropertyTypeSQLType}\"", debug)

         metadataConnection.setThisProperty( extName,
                                             extPropertyName,
                                             extValue,
                                             "=",
                                             propertiesOnSrvComp,
                                             true,
                                             overwriteValue:extOverwriteValue,
                                             propTypeName:extPropertyTypeName,
                                             propTypeSQL:extPropertyTypeSQLType )
      }

   }
   else
   {
      def e2 = new MdException("Extension sizes do not match: extensionNameList.size() " + extensionNameList.size() + "  extensionPropertyNameList.size() " + extensionPropertyNameList.size() + "  extensionValueList.size() " + extensionValueList.size() + "  extensionOverwriteValueList.size() " + extensionOverwriteValueList.size() + "  extensionPropertyTypeNameList.size() " + extensionPropertyTypeNameList.size() + "  extensionPropertyTypeSQLTypeList.size() " + extensionPropertyTypeSQLTypeList.size() )
      throw e2
   }
}
